#include "audio.h"

/*
   LOAD NEEDED SAMPLES
   --- for now it will load all, i'll see how memory usage looks later

*/

	//filenames
	char* fn[AUDIO_TOTAL];
	char* fn_track[TRACK_TOTAL];

	//sample handles
	FSOUND_SAMPLE* samples[AUDIO_TOTAL];

	FSOUND_SAMPLE* track_handle;
	int track_channel;
	int track_volumes[TRACK_TOTAL];

	//channels (start/stop/loop functions use these
	int channels[AUDIO_TOTAL];


void audioInit()
{
	if(!ENABLE_SOUND)return;

	//fn[AUDIO_MENU_LOOP] = "music/menu_loop.wav";
	fn[AUDIO_MENU_LOOP] = "audio/menu_loop.wav";
	fn[AUDIO_MENU_MOVE] = "audio/menu_move.wav";
	fn[AUDIO_MENU_START] = "audio/menu_start.wav";
	fn[AUDIO_VIRUS_SPAWN] = "audio/virus_spawn.wav";
	fn[AUDIO_SHOT] = "audio/shot.wav";
	fn[AUDIO_VIRUS_DEATH] = "audio/virus_death.wav";
	fn[AUDIO_LOSE] = "audio/lose.wav";
	fn[AUDIO_WIN] = "audio/win.wav";
	fn[AUDIO_REDCELL_HIT] = "audio/redcellhit.wav";

	fn_track[TRACK_SMACK_MY_BITCH_UP] = "audio/tracks/0.mp3";
	fn_track[TRACK_VOODOO_PENDULUM] = "audio/tracks/1.mp3";
	fn_track[TRACK_SMACK_MY_BITCH_UP_FATBOY] = "audio/tracks/2.mp3";
	fn_track[TRACK_SPITFIRE] = "audio/tracks/3.mp3";
	fn_track[TRACK_THEIR_LAW] = "audio/tracks/4.mp3";
	fn_track[TRACK_BREATHE] = "audio/tracks/5.mp3";
	fn_track[TRACK_MINDFIELDS] = "audio/tracks/6.mp3";
	fn_track[TRACK_POISON] = "audio/tracks/7.mp3";
	fn_track[TRACK_WIND_IT_UP] = "audio/tracks/8.mp3";
	fn_track[TRACK_NO_GOOD] = "audio/tracks/9.mp3";

	track_volumes[TRACK_SMACK_MY_BITCH_UP] = 77;
	track_volumes[TRACK_VOODOO_PENDULUM] = 72;
	track_volumes[TRACK_SMACK_MY_BITCH_UP_FATBOY] = 87;
	track_volumes[TRACK_SPITFIRE] = 78;
	track_volumes[TRACK_THEIR_LAW] = 87;
	track_volumes[TRACK_BREATHE] = 70;
	track_volumes[TRACK_MINDFIELDS] = 70;
	track_volumes[TRACK_POISON] = 75;
	track_volumes[TRACK_WIND_IT_UP] = 70;
	track_volumes[TRACK_NO_GOOD] = 78;

	FSOUND_Init(44100, 32, FSOUND_INIT_GLOBALFOCUS);

	for(int i=0; i<AUDIO_TOTAL; i++)
	{
		samples[i] = FSOUND_Sample_Load(FSOUND_FREE, fn[i], 0, 0, 0);

		channels[i] = i;
	}

}

void playTrack(int sampleNumber)
{
	//DEBUG TRACK VOLUME
	//sampleNumber = TRACK_VOODOO_PENDULUM;

	if(!ENABLE_SOUND)return;
	//ALWAYS loop
	track_handle = FSOUND_Sample_Load(FSOUND_FREE, fn_track[sampleNumber], 0, 0, 0);
	track_channel = FSOUND_PlaySound(FSOUND_FREE, track_handle);
	FSOUND_SetLoopMode(track_channel, AUDIO_LOOPMODE_LOOP);
	FSOUND_SetVolume(track_channel, track_volumes[sampleNumber]);
}

void stopTrack()
{
	if(!ENABLE_SOUND)return;
	FSOUND_StopSound(track_channel);
	FSOUND_Sample_Free(track_handle);
}


void playSampleRandomChannel(int sampleNumber)
{
	if(!ENABLE_SOUND)return;

	int channel = FSOUND_PlaySound(FSOUND_FREE, samples[sampleNumber]);
	FSOUND_SetLoopMode(channel, AUDIO_LOOPMODE_SINGLE);
}

//start playing sound, with the specified play mode
void playSample(int sampleNumber, unsigned int loopMode)
{
	if(!ENABLE_SOUND)return;

	if(loopMode == AUDIO_LOOPMODE_SINGLE)playSampleRandomChannel(sampleNumber);

	channels[sampleNumber] = FSOUND_PlaySound(FSOUND_FREE, samples[sampleNumber]);
	FSOUND_SetLoopMode(channels[sampleNumber], loopMode);

}

void stopSample(int sampleNumber)
{
	if(!ENABLE_SOUND)return;

	FSOUND_StopSound(channels[sampleNumber]);
}