#ifndef __AUDIO_H__
#define __AUDIO_H__


#include "fmod.h"
#include "fmod_errors.h"

#define AUDIO_LOOPMODE_LOOP FSOUND_LOOP_NORMAL | FSOUND_16BITS | FSOUND_SIGNED | FSOUND_STEREO
#define AUDIO_LOOPMODE_SINGLE FSOUND_16BITS | FSOUND_SIGNED | FSOUND_STEREO

//0 = sounds off -- also eliminates dependencies on audio and tracks
//1 = sounds enabled
#define ENABLE_SOUND 1

//these are sounds that get loaded at game init time
#define AUDIO_TOTAL 9
#define AUDIO_MENU_LOOP 0
#define AUDIO_MENU_MOVE 1
#define AUDIO_MENU_START 2
#define AUDIO_VIRUS_SPAWN 3
#define AUDIO_SHOT 4
#define AUDIO_VIRUS_DEATH 5
#define AUDIO_LOSE 6
#define AUDIO_WIN 7
#define AUDIO_REDCELL_HIT 8


//these are level tracks that get loaded at level init time
#define TRACK_TOTAL 10
#define TRACK_SMACK_MY_BITCH_UP 0
#define TRACK_VOODOO_PENDULUM 1
#define TRACK_SMACK_MY_BITCH_UP_FATBOY 2
#define TRACK_SPITFIRE 3
#define TRACK_THEIR_LAW 4
#define TRACK_BREATHE 5
#define TRACK_MINDFIELDS 6
#define TRACK_POISON 7
#define TRACK_WIND_IT_UP 8
#define TRACK_NO_GOOD 9



//called once, this loads all samples
void audioInit();

void playSampleRandomChannel(int sampleNumber);

//start playing sound, with the specified play mode
void playSample(int sampleNumber, unsigned int loopMode);

//stop sample
void stopSample(int sampleNumber);

void playTrack(int sampleNumber);
void stopTrack();


#endif
