#include <math.h>
#include <stdarg.h>
#include <windows.h>											// Header File For Windows
#include <stdio.h>												// Header File For Standard Input/Output
#include <gl\gl.h>												// Header File For The OpenGL32 Library
#include <gl\glu.h>												// Header File For The GLu32 Library
#include "Texture.h"										// Header File Containing Our Texture Structure ( NEW )
#include "constants.h"
#include "gmd3.h"
#include "virus.h"
#include "player.h"
#include "objective.h"

//mp3 playback
#include "audio.h"

#pragma comment( lib, "opengl32.lib" )
#pragma comment( lib, "glu32.lib" )	
#pragma comment( lib, "glaux.lib" )	
#pragma comment( lib, "winmm.lib" )
#pragma comment( lib, "fmodvc.lib" )


HDC			hDC=NULL;											// Private GDI Device Context
HGLRC		hRC=NULL;											// Permanent Rendering Context
HWND		hWnd=NULL;											// Holds Our Window Handle
HINSTANCE	hInstance;											// Holds The Instance Of The Application
BOOL	done=FALSE;	//EXIT PROGRAM?


//FONT
GLuint	base;				// Base Display List For The Font Set

bool	keys[256];

//how the keys looked like last frame
bool	last_keys[256];

bool	active=TRUE;
bool	fullscreen=TRUE;

double window_height;
double window_width;

//MOUSE
double posX, posY, posZ;
double winX, winY, winZ;
double mwheel = 0.0;
int clicked = 0;
int rclicked = 0;

//frame per second control
DWORD start_time_ = GetTickCount();

//bring the screen to [min_width, max_width] horizontally, and [-1.0, 1.0] vertically
double max_width;
double min_width;

int frame_number=0;

player pl;
int total_hp;

int shot=0;
int shot_frames_total = 10;
int shot_frames=shot_frames_total;


double red_under_mouse;

unsigned char global_red, global_green, global_blue;


/*
 } MENU SPECIFIC
 |
 |*/
//rotation of main menu tex
double xd=0;
//menu selector
int menu_selector = MENU_START;

//initial level when menu starts
int menu_level = 1;


/*
 |  AUDIO SPECIFIC
 |
 */
int menu_playing = 0;
int last_track = -1;

/*
 |  LEVEL and BOUNDS specific
 |
 */
double field_width = 9.0;
double field_height = 6.0;
double field_translation_x = 0.0;
double field_translation_y = 1.0;
int total_spawns = 2;
int total_viruses = 0;

int lost_level_texture=0;

void initResources();
bool LoadTGA(Texture *, char *);

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

/*
	======================
	End header definitions
	======================
*/


//===========FONT=============
GLvoid BuildFont(GLvoid)								// Build Our Bitmap Font
{
	return;
/*
	HFONT	font;										// Windows Font ID
	HFONT	oldfont;									// Used For Good House Keeping

	base = glGenLists(96);								// Storage For 96 Characters

	font = CreateFont(	-9,							// Height Of Font
						0,								// Width Of Font
						0,								// Angle Of Escapement
						0,								// Orientation Angle
						FW_BOLD,						// Font Weight
						FALSE,							// Italic
						FALSE,							// Underline
						FALSE,							// Strikeout
						ANSI_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// Output Precision
						CLIP_DEFAULT_PRECIS,			// Clipping Precision
						ANTIALIASED_QUALITY,			// Output Quality
						FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
						"Bookman Old Style");					// Font Name

	oldfont = (HFONT)SelectObject(hDC, font);           // Selects The Font We Want
	wglUseFontBitmaps(hDC, 32, 96, base);				// Builds 96 Characters Starting At Character 32
	SelectObject(hDC, oldfont);							// Selects The Font We Want
	DeleteObject(font);									// Delete The Font
	*/
}

GLvoid KillFont(GLvoid)									// Delete The Font List
{
	glDeleteLists(base, 96);							// Delete All 96 Characters
}

GLvoid glPrint(const char *fmt, ...)					// Custom GL "Print" Routine
{
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(base - 32);								// Sets The Base Character to 32
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits
}

//==================== END FONT ======================

int LoadGLTextures()											// Load Bitmaps And Convert To Textures
{
	// Load The Bitmap, Check For Errors.
	for(int texcount=0;texcount<MAXTEXTURES;texcount++)
	{
		char filename[128];
		sprintf(filename, "Data/%d.tga", texcount);
		if(!LoadTGA(&tex[texcount], filename))
		{
			return FALSE;
		}
	}
		

	for (int loop=0; loop<MAXTEXTURES; loop++)						// Loop Through Both Textures
	{
		// Typical Texture Generation Using Data From The TGA ( CHANGE )
		glGenTextures(1, &tex[loop].texID);				// Create The Texture ( CHANGE )
		glBindTexture(GL_TEXTURE_2D, tex[loop].texID);
		glTexImage2D(GL_TEXTURE_2D, 0, tex[loop].bpp / 8, tex[loop].width, tex[loop].height, 0, tex[loop].type, GL_UNSIGNED_BYTE, tex[loop].imageData);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		
		if (tex[loop].imageData)						// If Texture Image Exists ( CHANGE )
		{
			free(tex[loop].imageData);					// Free The Texture Image Memory ( CHANGE )
		}
	}

	return TRUE;												// Return The Status
}

GLvoid ReSizeGLScene(GLsizei width, GLsizei height)				// Resize And Initialize The GL Window
{
	if (height==0)												// Prevent A Divide By Zero By
	{
		height=1;												// Making Height Equal One
	}

	window_height = height;
	window_width = width;

	max_width = window_width / window_height;
	min_width = -1.0*max_width;

	glViewport(0,0,width,height);								// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);								// Select The Projection Matrix
	glLoadIdentity();											// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);									// Select The Modelview Matrix
	glLoadIdentity();											// Reset The Modelview Matrix
}

int InitGL(GLvoid)												// All Setup For OpenGL Goes Here
{
	if (!LoadGLTextures())										// Jump To Texture Loading Routine ( NEW )
	{
		return FALSE;											// If Texture Didn't Load Return FALSE
	}

	glEnable(GL_TEXTURE_2D);									// Enable Texture Mapping ( NEW )
	glShadeModel(GL_SMOOTH);									// Enable Smooth Shading
	glClearColor(0.0f, 0.0f, 0.0f, 0.5f);						// Black Background
	glClearDepth(1.0f);											// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);									// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);										// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);			// Really Nice Perspective Calculations

	BuildFont();

	return TRUE;												// Initialization Went OK
}


GLvoid KillGLWindow(GLvoid)										// Properly Kill The Window
{
	if (fullscreen)												// Are We In Fullscreen Mode?
	{
		ChangeDisplaySettings(NULL,0);							// If So Switch Back To The Desktop
		ShowCursor(TRUE);										// Show Mouse Pointer
	}

	if (hRC)													// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))							// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))								// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;												// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))							// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;												// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))							// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;												// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))					// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;											// Set hInstance To NULL
	}
}

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;									// Holds The Results After Searching For A Match
	WNDCLASS	wc;												// Windows Class Structure
	DWORD		dwExStyle;										// Window Extended Style
	DWORD		dwStyle;										// Window Style
	RECT		WindowRect;										// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;									// Set Left Value To 0
	WindowRect.right=(long)width;								// Set Right Value To Requested Width
	WindowRect.top=(long)0;										// Set Top Value To 0
	WindowRect.bottom=(long)height;								// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;									// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}
	
	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;								// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	//else
	if(!fullscreen)
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		//dwExStyle=WS_EX_APPWINDOW;
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
		ShowCursor(FALSE);
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);	// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	
	static	PIXELFORMATDESCRIPTOR pfd=							// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),							// Size Of This Pixel Format Descriptor
		1,														// Version Number
		PFD_DRAW_TO_WINDOW |									// Format Must Support Window
		PFD_SUPPORT_OPENGL |									// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,										// Must Support Double Buffering
		PFD_TYPE_RGBA,											// Request An RGBA Format
		bits,													// Select Our Color Depth
		0, 0, 0, 0, 0, 0,										// Color Bits Ignored
		1,														// No Alpha Buffer
		0,														// Shift Bit Ignored
		0,														// No Accumulation Buffer
		0, 0, 0, 0,												// Accumulation Bits Ignored
		16,														// 16Bit Z-Buffer (Depth Buffer)  
		0,														// No Stencil Buffer
		0,														// No Auxiliary Buffer
		PFD_MAIN_PLANE,											// Main Drawing Layer
		0,														// Reserved
		0, 0, 0													// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))										// Did We Get A Device Context?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))				// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))					// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))							// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))								// Try To Activate The Rendering Context
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);									// Show The Window
	SetForegroundWindow(hWnd);									// Slightly Higher Priority
	SetFocus(hWnd);												// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);								// Set Up Our Perspective GL Screen

	if (!InitGL())												// Initialize Our Newly Created GL Window
	{
		KillGLWindow();											// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	return TRUE;												// Success
}

LRESULT CALLBACK WndProc(	HWND	hWnd,						// Handle For This Window
							UINT	uMsg,						// Message For This Window
							WPARAM	wParam,						// Additional Message Information
							LPARAM	lParam)						// Additional Message Information
{
	switch (uMsg)												// Check For Windows Messages
	{
		case WM_ACTIVATE:										// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))								// Check Minimization State
			{
				active=TRUE;									// Program Is Active
			}
			else
			{
				active=FALSE;									// Program Is No Longer Active
			}

			return 0;											// Return To The Message Loop
		}

		case WM_SYSCOMMAND:										// Intercept System Commands
		{
			switch (wParam)										// Check System Calls
			{
				case SC_SCREENSAVE:								// Screensaver Trying To Start?
				case SC_MONITORPOWER:							// Monitor Trying To Enter Powersave?
				return 0;										// Prevent From Happening
			}
			break;												// Exit
		}

		case WM_CLOSE:											// Did We Receive A Close Message?
		{
			PostQuitMessage(0);									// Send A Quit Message
			return 0;											// Jump Back
		}

		case WM_KEYDOWN:										// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;								// If So, Mark It As TRUE
			return 0;											// Jump Back
		}

		case WM_KEYUP:											// Has A Key Been Released?
		{
			keys[wParam] = FALSE;								// If So, Mark It As FALSE
			return 0;											// Jump Back
		}

		//for mouse
		case WM_LBUTTONDOWN:
		{
			clicked = 1;
			return 0;
		}
		case WM_LBUTTONUP:
		{
			clicked = 0;
			return 0;
		}

		case WM_RBUTTONDOWN:
		{
			rclicked = 1;
			return 0;
		}
		case WM_RBUTTONUP:
		{
			rclicked = 0;
			return 0;
		}


		case WM_SIZE:											// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));		// LoWord=Width, HiWord=Height
			return 0;											// Jump Back
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,						// Instance
					HINSTANCE	hPrevInstance,					// Previous Instance
					LPSTR		lpCmdLine,						// Command Line Parameters
					int			nCmdShow)						// Window Show State
{
	MSG		msg;												// Windows Message Structure

	int w, h, bpp, full;

	FILE *fp;
	fp = fopen("Config/default.ini", "r");
	fscanf(fp, "%d\n%d\n%d\n%d", &w, &h, &bpp, &full);
	fclose(fp);

	//vsync disable
	BOOL (APIENTRY *wglSwapIntervalEXT)(int);
	wglSwapIntervalEXT=( BOOL (APIENTRY*)(int) )wglGetProcAddress("wglSwapIntervalEXT");
	if (wglSwapIntervalEXT)wglSwapIntervalEXT(1);


	// Create Our OpenGL Window
	int dummy = CreateGLWindow("",w, h, bpp, /*fullscreen*/full);
	if (dummy == 0)
	{
		return 0;												// Quit If Window Was Not Created
	}

	audioInit();

	while(!done)												// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))				// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)							// Have We Received A Quit Message?
			{
				done=TRUE;										// If So done=TRUE
			}
			else												// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);							// Translate The Message
				DispatchMessage(&msg);							// Dispatch The Message
			}
		}
		else													// If There Are No Messages
		{
			if(keys[VK_ESCAPE])
			{
				//done=TRUE;
			}


			


			//reset keypresses if minimized
			if(!active)
			{
				for(int i=0;i<256;i++){
					keys[i]=FALSE;
				}
			}

			if (active)	// Active?  Was There A Quit Received?
			{
				if(!GamePreFrame()){
					done=TRUE;
				}else if(!GameFrame()){
					done=TRUE;
				}else if(!GamePostFrame()){
					done=TRUE;
				}
			}
			
			if(!done)
			{
				SwapBuffers(hDC);								// Swap Buffers (Double Buffering)
			}



			/*if (keys[VK_F1])									// Is F1 Being Pressed?
			{
				keys[VK_F1]=FALSE;								// If So Make Key FALSE
				KillGLWindow();									// Kill Our Current Window
				fullscreen=!fullscreen;							// Toggle Fullscreen / Windowed Mode
				// Recreate Our OpenGL Window
				if (!CreateGLWindow("",640,480,32,fullscreen))
				{
					return 0;									// Quit If Window Was Not Created
				}
			}*/
			
			//key handling here or even better in PreFrame()

		}
	}

	//stop mp3
	//FSOUND_StopSound(m_soundChannel);

	// Shutdown
	PostQuitMessage(0);
	KillGLWindow();												// Kill The Window
	return (msg.wParam);										// Exit The Program
}

void showMouse()
{
	glPushMatrix();
	
	glLoadIdentity();
	glTranslatef(posX, posY, -10.0);
	glScalef(0.2, 0.2, 1.0);
	drawTexturedSquare(7);
	glPopMatrix();
}

int GameFrame(GLvoid)											// Here's Where We Do All The Drawing
{

	glClearColor(0.0f, 0.0f, 0.00f, 1.0f);
	//glClearColor(1.0f,1.0f,1.05f,1.0f);

    // OK, now clear the screen with the background colour
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);  

    // Setup the model-view transformation matrix
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
	//glScalef((double)(window_height/window_width), 1.0f, 1.0f);
	//glScalef(0.75, 0.5, 1.0);

    glTranslatef(0.0f, 0.0f, -10.0f);
	glPushMatrix();
	
	glAlphaFunc( GL_GREATER, 0.5 );
	glEnable( GL_ALPHA_TEST );

	glColor3f(1.0f, 1.0f, 1.0f);

	if(game_state==STATE_LOST)
	{
		//still display last frame of STATE_PLAY, but dont update anything anymore
		handlePlayState();

		//now display "you lost" message
		loseLevelMessage();
	}

	if(game_state==STATE_WIN)
	{
		//still display last frame of STATE_PLAY, but dont update anything anymore
		handlePlayState();

		//now display "you lost" message
		winLevelMessage();
	}

	//allow 5 seconds of no spawns or shots at the beginning of level
	if(game_state==STATE_PLAY)
	{
		//level has been initialized from Preframe, at key hit time
		if(frame_number>150)handleShot();
		if(frame_number>150)updateViruses();
		handlePlayState();

		if(frame_number>150)checkWinLevel();
		if(frame_number>150)checkLoseLevel();
	}

	if(game_state==STATE_MAIN)
	{
		handleMainState();
	}
	
	if(game_state==STATE_VICTORY)
	{
		handleVictoryState();
	}

	//display blank tex
	glPushMatrix();//3
	glColor3f(1.0, 1.0, 1.0);
	glTranslatef(-1000.0f, 0.0f, 0.0f);
	drawTexturedSquare(0);
	glPopMatrix();//3

	showMouse();

	glPopMatrix();

	return TRUE;												// Keep Going
}


// PREFRAME HELPER -- WAS A KEY PRESSED/DEPRESSED?
int wasPressedDepressed(int key)
{
	if(last_keys[key] && !keys[key])return 1;
	return 0;
}


/*==============================================================
|
|
|              PREFRAME AND POSTFRAME
|
|
===============================================================*/

int GamePreFrame()
{
	frame_number++;

	//mouse refresh
	POINT p;
	GetCursorPos(&p);
	GetMouseCoords(p.x, p.y);
	
	red_under_mouse = (double)readPixelUnderMouse(p.x, p.y);

	// HANDLE MENU
	if(game_state==STATE_MAIN)
	{
		double amount = 0.08f;
		xd += amount;

		if(!menu_playing)
		{
			playSample(AUDIO_MENU_LOOP, AUDIO_LOOPMODE_LOOP);
			menu_playing = 1;
		}

		//CHECK DEPRESS/PRESSES
		if(wasPressedDepressed(VK_DOWN))
		{
			//move menu selector down
			menu_selector++;
			if(menu_selector >= MENU_TOTAL) menu_selector=0;
			playSample(AUDIO_MENU_MOVE, AUDIO_LOOPMODE_SINGLE);
		}
		if(wasPressedDepressed(VK_UP))
		{
			//move menu selector down
			menu_selector--;
			if(menu_selector < 0) menu_selector=MENU_TOTAL - 1;
			playSample(AUDIO_MENU_MOVE, AUDIO_LOOPMODE_SINGLE);
		}

		if(wasPressedDepressed(VK_RIGHT) && menu_selector == MENU_LEVEL)
		{
			menu_level ++;
			if(menu_level > MAX_LEVEL)menu_level--;
			playSample(AUDIO_MENU_MOVE, AUDIO_LOOPMODE_SINGLE);
		}
		if(wasPressedDepressed(VK_LEFT) && menu_selector == MENU_LEVEL)
		{
			menu_level --;
			if(menu_level < 1)menu_level++;
			playSample(AUDIO_MENU_MOVE, AUDIO_LOOPMODE_SINGLE);
		}
		
		if(wasPressedDepressed(VK_RETURN)) 
		{
			if(menu_selector == MENU_START)
			{
				game_state = STATE_PLAY;
				playSample(AUDIO_MENU_START, AUDIO_LOOPMODE_SINGLE);
				initializeLevel();
				//reset frame count
				frame_number = 0;
				stopSample(AUDIO_MENU_LOOP);
				menu_playing = 0;

				//PLAY LEVEL TRACK
				//playTrack(TRACK_SMACK_MY_BITCH_UP);
				//playTrack(TRACK_VOODOO_PENDULUM);
				playLevelTrack();

			}
			if(menu_selector == MENU_QUIT)
			{
				done = 1;
			}

		}

	}//END IF IN MAIN MENU

	if(game_state == STATE_PLAY)
	{
		if(frame_number>150)cycleSpawns();

		//make objective pulsate
		double factor = (double)(frame_number % 20) / 100.0;
		object.scale = object.initial_scale + factor;

		//move player
		if(keys['W'])movePlayer(&pl, 0.0, pl.dy, field_width, field_height);
		if(keys['S'])movePlayer(&pl, 0.0, -pl.dy, field_width, field_height);
		if(keys['D'])movePlayer(&pl, pl.dx, 0.0, field_width, field_height);
		if(keys['A'])movePlayer(&pl, -pl.dx, 0.0, field_width, field_height);

		//only handle clicks if not currently shooting
		if(clicked && !shot)updateCharge(posX, posY);
		if(rclicked && !shot)
		{
			pl.charge[0]=0; pl.charge[1]=0; pl.charge[2]=0;
		}

		if(keys[VK_SPACE] && frame_number>150)
		{
			//did we just start a shot?
			if(shot==0)playSample(AUDIO_SHOT, AUDIO_LOOPMODE_SINGLE);
			shot=1;
		}

		if(wasPressedDepressed(VK_ESCAPE))
		{
			stopTrack();
			game_state = STATE_MAIN;
		}

	}//END IF STATE_PLAY

	if(game_state == STATE_LOST)
	{
		if(clicked)
		{
			if(posX>-0.399 && posX<0.269 &&
			   posY>-1.5 && posY<-1.0)
			{
				//return to menu after cleaning up.
				cleanUp();
				stopTrack();
				menu_playing = 0;
				game_state=STATE_MAIN;
			}
		}
	}//END IF STATE_LOST

	if(game_state == STATE_WIN)
	{
		if(clicked)
		{
			if(posX>-0.399 && posX<0.269 &&
			   posY>-1.5 && posY<-1.0)
			{	
				//go to next level if clicked
				cleanUp();
				stopTrack();
				game_state = STATE_PLAY;
				playSample(AUDIO_MENU_START, AUDIO_LOOPMODE_SINGLE);
				frame_number = 0;
				menu_playing = 0;
				
				//player won a custom level so go back to menu
				if(menu_level==CUSTOM_LEVEL)
				{
					menu_level = 1;
					game_state=STATE_MAIN;
				}

				//PLAYER BEAT THE GAME!!
				if(menu_level==MAX_LEVEL)
				{
					game_state = STATE_VICTORY;
				}
				else //didnt yet beat game
				{
					menu_level ++;
					initializeLevel();
					playLevelTrack();
				}
			}
		}//end if clicked
	}//END IF STATE_WIN

	if(game_state==STATE_VICTORY)
	{
		if(wasPressedDepressed(VK_RETURN))
		{
			menu_level = 1;
			game_state = STATE_MAIN;
		}
	}//END IF STATE_VICTORY


	return TRUE;
}


//POSTFRAME HELPER -- WAIT FOR NEXT FRAME
void gameWait()
{
	static int frcnt = 1;
	static double fpsunlocked = 0.0;
	if(GetTickCount()-start_time_ != 0.0)
	{
		fpsunlocked += 1000/(GetTickCount()-start_time_+0.000001);
		frcnt++;
	}
	
	double wait_val = 27.0;
	while((GetTickCount() - start_time_) < wait_val )
	{
		Sleep(5);
	}

	//double fps=1000/(GetTickCount()-start_time_+0.000001);
	//double fps=GetTickCount()-start_time_;
	//glPrint("fps(locked)=%2.0f", fps);

	start_time_ = GetTickCount();
}

/*=======================================
|
|          POSTFRAME
========================================*/
int GamePostFrame()
{

	//copy keys into last_keys
	for(int i=0; i<256 ; i++)last_keys[i] = keys[i];

	glDisable( GL_ALPHA_TEST );
	glColor3f(1.0f, 1.0f, 1.0f);
	
	//glRasterPos2f(0.00f, 0.00f);
	//glPrint(" menu selector %d", menu_selector);
	//glPrint("posX: %f   posY:%f  posZ:%f", posX, posY, posZ);
	//glRasterPos2f(0.00f, -1.25f);
	//glPrint("posX: %f   posY:%f  posZ:%f", posX, posY, posZ);
	//glPrint("winx: %f   winy:%f  winz:%f", winX, winY, winZ);
	//glPrint("virus 0:   (%f, %f)",viruses[0]->x, viruses[0]->y );
	//glRasterPos2f(0.00f, -1.5f);
	//glPrint("plX: %f   plY:%f", pl.x, pl.y);
/*
	if(game_state==STATE_PLAY)
	{
		if(viruses[0]!=NULL)
		{
		glRasterPos2f(0.00f, 0.00f);
		glPrint("virus 0:   (%f, %f)",viruses[0]->x, viruses[0]->y );
		glRasterPos2f(0.00f, -0.50f);
		glPrint("virus 0 direction:   (%f, %f)",viruses[0]->dirx, viruses[0]->diry );
		}

		glRasterPos2f(0.0, -1.0);
		glPrint("Viruses: %d", getActiveViruses());

		glRasterPos2f(0.0, 1.0);
		glPrint("red cell HP: %d", object.health);

		glRasterPos2f(0.0, 1.3);
		glPrint("track: %d", last_track);

		glRasterPos2f(0.0, 1.5);
		glPrint("frame: %d", frame_number);
	}
*/
	gameWait();

	return TRUE;
}


void drawTexturedSquare(int texturenr)
{
	glBindTexture(GL_TEXTURE_2D, tex[texturenr].texID);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0, 1.0f); glVertex3f(-0.5,0.5, 0.0f);
		glTexCoord2f(1.0, 1.0f); glVertex3f(0.5,0.5, 0.0f);
		glTexCoord2f(1.0, 0.0f); glVertex3f(0.5,-0.5, 0.0f);
		glTexCoord2f(0.0, 0.0f); glVertex3f(-0.5,-0.5, 0.0f);
	glEnd();
}

void drawTexturedSquareCoords(int texturenr, double left, double right, double top, double bottom)
{
	glBindTexture(GL_TEXTURE_2D, tex[texturenr].texID);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0, 1.0f); glVertex3f(left,top, 0.0f);
		glTexCoord2f(1.0, 1.0f); glVertex3f(right,top, 0.0f);
		glTexCoord2f(1.0, 0.0f); glVertex3f(right,bottom, 0.0f);
		glTexCoord2f(0.0, 0.0f); glVertex3f(left,bottom, 0.0f);
	glEnd();
}


void updateViruses()
{
	for(int i=0;i<MAXVIRUSES;i++)
	{
		if(viruses[i]!=NULL)
		{
			changeHandler(viruses[i], frame_number, &object);
			moveVirus(viruses[i], field_width, field_height);

			int hit = checkHitByVirus(&object, viruses[i]);

			//in case of a hit, destroy virus
			if(hit)
			{
				//play sound
				playSample(AUDIO_REDCELL_HIT, AUDIO_LOOPMODE_SINGLE);

				free(viruses[i]);
				viruses[i]=NULL;
			}
		}
	}
}


/* 
 |
 |   PLAY STATE
 |
 */
void handlePlayState()
{

	//global background
	glPushMatrix();
	glColor3f(1.0, 1.0, 1.0);
	glScalef(11.0, 9.0, 1.0);
	drawTexturedSquare(11);
	glPopMatrix();

	//draw play ares (black rectangle for now
	glPushMatrix();
	glTranslatef(field_translation_x, field_translation_y, 0.0);
	glScalef(field_width*1.04, field_height*1.04, 1.0);

	double col;
	if(frame_number % 80 < 39)col = (frame_number % 80) / 100.0;
	else col = 0.8 - (frame_number % 80) / 100.0;	
	glColor3f(0.4 + col, 0.23, 0.5);
	drawTexturedSquare(9);

	glPopMatrix();
	glTranslatef(field_translation_x, field_translation_y, 0.0);

	//display viruses
	for(int i=0; i<MAXVIRUSES; i++)
	{
	  if(viruses[i]!=NULL)
	  {
		glPushMatrix();
		glColor3f((double)(viruses[i]->color[0]/ 100.0), 
			      (double)(viruses[i]->color[1]/ 100.0),
				  (double)(viruses[i]->color[2]/ 100.0));
		
		glTranslatef(viruses[i]->x,
			        viruses[i]->y,
					0.0);
		glRotatef(viruses[i]->angle, 0.0, 0.0, 1.0);
		glScalef(viruses[i]->scale, viruses[i]->scale, 1.0);
		//glScalef(0.1, 0.1, 1.0);
		drawTexturedSquare(viruses[i]->texture);
		glPopMatrix();
	  }
	}

	//display objective
	glPushMatrix();
	glColor3f(COLOR_WHITE);
	
	glTranslatef(object.x,
			     object.y,
				 0.0);
	glScalef(object.scale, object.scale, 1.0);
	drawTexturedSquare(object.texture);
	glPopMatrix();

	//display spawns
	for(i=0;i<MAXSPAWNS;i++)
	{
		if(spawns[i]!=NULL && spawns[i]->viruses_left>0)
		{
			glPushMatrix();
			glColor3f(COLOR_WHITE);
			
			glTranslatef(spawns[i]->x,
			     spawns[i]->y,
				 0.0);
			glScalef(0.5, 0.5, 1.0);
			drawTexturedSquare(8);
			glPopMatrix();
		}
	}

	//display shot radius only if firing
	if(shot)
	{
		glPushMatrix();
		/*glColor3f(  (double)(pl.charge[0] * shot_frames) / (double)(100 * shot_frames_total),
					(double)(pl.charge[1] * shot_frames) / (double)(100 * shot_frames_total),
					(double)(pl.charge[2] * shot_frames) / (double)(100 * shot_frames_total));
		*/
		glColor3f(  (double)(pl.charge[0]) / 100.0,
					(double)(pl.charge[1]) / 100.0,
					(double)(pl.charge[2]) / 100.0);
		glTranslatef(pl.x,
					pl.y,
					0.0);
		double shot_scale = (double)(shot_frames_total-shot_frames)/(double)shot_frames_total;
		//glRotatef(360.0 * shot_scale, 0.0, 0.0, 1.0);
		glScalef(pl.shot_scale, 
				pl.shot_scale, 
				1.0);
		drawTexturedSquare(28);
		glPopMatrix();
	}

	//display player
	glPushMatrix();
	glColor3f(COLOR_WHITE);
	
	glTranslatef(pl.x,
			     pl.y,
				 0.0);
	glScalef(pl.scale, pl.scale, 1.0);
	drawTexturedSquare(pl.texture);
	glPopMatrix();


	//display charge selector
	glPushMatrix();
	glTranslatef(2.75, -3.75, 0.0);
	glScalef(1.5, 1.3, 1.0);

	//black background of selector
	glPushMatrix();
	glTranslatef(0.0, -0.15, 0.0);
	glScalef(1.1, 1.3, 1.0);
	glColor3f(COLOR_WHITE);
	drawTexturedSquare(19);
	glPopMatrix();

	glPopMatrix();

	glPushMatrix();
	glColor3f(COLOR_WHITE);
	glTranslatef(2.20, -3.75, 0.0);
	glScalef(0.4, 0.8, 1.0);
	drawTexturedSquare(20);
	bogusTexture();
	box();
	glTranslatef(1.4, 0.0, 0.0);
	drawTexturedSquare(21);
	bogusTexture();
	box();
	glTranslatef(1.4, 0.0, 0.0);
	drawTexturedSquare(22);
	bogusTexture();
	box();
	glPopMatrix();

	
	//display charge
	glPushMatrix();
	glTranslatef(0.0, -3.75, 0.0);

	//small black circle around charge
	glPushMatrix();
	glScalef(1.2, 1.2, 1.0);
	glColor3f(COLOR_BLACK);
	drawTexturedSquare(23);
	glPopMatrix();

	glColor3f((double)pl.charge[0]/100.0, 
			  (double)pl.charge[1]/100.0, 
			  (double)pl.charge[2]/100.0);
	drawTexturedSquare(23);

	//draw box around controls
	glPushMatrix();
	glTranslatef(0.0, -0.30, 0.0);
	glScalef(9.0, 2.0, 1.0);
	glColor3f(COLOR_BLACK);
	bogusTexture();
	box();
	glPopMatrix();

	glColor3f(0.9, 0.9, 0.9);
	glTranslatef(0.0, -0.75, 0.0);
	glScalef(0.6, 0.3, 1.0);
	drawTexturedSquare(24);
	glPopMatrix();


	//red cell hp
	//if(frame_number % 3==0 && object.health>0)object.health--;

	double left = -4.3;
	double up = -3.2;
	double hp_ratio = (double)object.health / (double)object.total_health;
	glColor3f(COLOR_WHITE);
	drawTexturedSquareCoords(0, left, left+hp_ratio, up, up-0.15);
	glColor3f(COLOR_BLACK);
	boxCoords(left, left+1.0, up, up-0.15);
	glColor3f(COLOR_WHITE);
	drawTexturedSquareCoords(25, left + 1.1, left + 1.9, up, up-0.15);

	//viruses remaining (counting the ones that haven't yet spawned
	up = -3.5;
	double virus_ratio = (double)countPotentialViruses() / (double)total_viruses;
	glColor3f(COLOR_BLACK);
	drawTexturedSquareCoords(0, left, left+virus_ratio, up, up-0.15);
	glColor3f(COLOR_BLACK);
	boxCoords(left, left+1.0, up, up-0.15);
	glColor3f(COLOR_WHITE);
	drawTexturedSquareCoords(26, left + 1.1, left + 1.9, up, up-0.15);

	up = -4.2;
	double red_ratio = (double)pl.remaining[0] / (double)pl.total[0];
	if(pl.total[0]==0)red_ratio=0.0;
	glColor3f(COLOR_RED);
	drawTexturedSquareCoords(0, left, left+red_ratio, up, up-0.15);
	glColor3f(COLOR_BLACK);
	boxCoords(left, left+1.0, up, up-0.15);

	up = -4.5;
	double green_ratio = (double)pl.remaining[1] / (double)pl.total[1];
	if(pl.total[1]==0)green_ratio=0.0;
	glColor3f(COLOR_GREEN);
	drawTexturedSquareCoords(0, left, left+green_ratio, up, up-0.15);
	glColor3f(COLOR_BLACK);
	boxCoords(left, left+1.0, up, up-0.15);
	glColor3f(COLOR_WHITE);
	drawTexturedSquareCoords(27, left + 1.1, left + 1.9, up, up-0.15);

	up = -4.8;
	double blue_ratio = (double)pl.remaining[2] / (double)pl.total[2];
	if(pl.total[2]==0)blue_ratio=0.0;
	glColor3f(COLOR_BLUE);
	drawTexturedSquareCoords(0, left, left+blue_ratio, up, up-0.15);
	glColor3f(COLOR_BLACK);
	boxCoords(left, left+1.0, up, up-0.15);
}


/* 
 |
 |   MAIN MENU
 |
 */
void handleMainState()
{

	glPushMatrix(); //1
	glColor3f( min(xd/25, 0.75) , 0.0, 0.3);
	glScalef(15.0f, 15.0f, 1.0f);
	glRotatef(10*xd, 0.0, 0.0, 1.0);
	drawTexturedSquare(1);
	glPopMatrix();//1

	//display title
	glPushMatrix();
	glColor3f(COLOR_WHITE);
	glTranslatef(0.0, 2.0, 0.0);
	glScalef(2.0, 1.0, 1.0);
	drawTexturedSquare(33);
	glPopMatrix();

	//display menu
	double yoffset = -2.9;
	glPushMatrix();//2
	glTranslatef(-4.5, yoffset, 0.0);
	glScalef(1.0, 1.5, 1.0);
	glColor3f(1.0,1.0,1.0);
	drawTexturedSquare(2);
	glPushMatrix(); //22

	//display pointer
	double offset = -0.35;
	double current_pos = offset * menu_selector;
	//move to corner
	glTranslatef(-0.25, 0.4, 0.0);

	//display level bars
	glPushMatrix();//23
	glTranslatef(0.75, offset * MENU_LEVEL, 0.0);
	glScalef(0.075, 0.15, 1.0);
	for(int i=1; i<=menu_level;i++)
	{
		glTranslatef(1.5, 0.0, 0.0);
		double col = (double)i/MAX_LEVEL*0.9 + 0.2;
		glColor3f(1.0, 1-col, 1-col);
		drawTexturedSquare(0);
	}
	glPopMatrix();//23

	glTranslatef(0.0, current_pos, 0.0);
	glColor3f(COLOR_WHITE);

	glScalef(0.2, 0.1, 1.0);
	glRotatef(-50*xd, 0.0, 0.0, 1.0);
	drawTexturedSquare(0);
	glRotatef(45.0, 0.0, 0.0, 1.0);
	drawTexturedSquare(0);
	glPopMatrix();//22

	//display help
	glTranslatef(0.0, 0.75, 0.0);
	glScalef(1.0, 0.5, 1.0);
	glColor3f(COLOR_WHITE);
	if(menu_selector == MENU_START) drawTexturedSquare(4);
	if(menu_selector == MENU_LEVEL) drawTexturedSquare(5);

	glPopMatrix();//2
}

void initializeLevel()
{
	for(int i=0; i<MAXVIRUSES; i++) viruses[i] = NULL;
	for(i=0; i<MAXSPAWNS; i++) spawns[i] = NULL;

	srand(GetTickCount());

	//viruses
/*	for(i=0; i<menu_level; i++)
	{
		int index = findAvailableVirusSpot();

		//no virus spots available
		if(index<0)break;

		viruses[index] = createGenericVirus();
		viruses[index]->last_decision = frame_number;
	}
*/
/*	//spawns
	for(i=0; i<total_spawns; i++)
	{
		int index = findAvailableSpawnSpot();

		//no spawn spots available
		if(index<0)break;

		spawns[index] = createSpawn();
	}
*/
	object = createObjective(3.0, 0.0, 100);
	pl.x = 0.0;
	pl.y = 0.0;
	pl.dx = 0.075;
	pl.dy = 0.075;
	pl.texture = 14;
	pl.scale = 0.25;
	pl.charge[0] = 0;pl.charge[1] = 0;pl.charge[2] = 0;
	pl.remaining[0] = 200;pl.remaining[1] = 200;pl.remaining[2] = 200;
	pl.subtracted = 0;
	loadLevel(menu_level);

	total_viruses = countPotentialViruses();
}


void GetMouseCoords(int x, int y)
{
	GLint viewport[4];
	GLdouble modelview[16];
	GLdouble projection[16];
	
	glGetDoublev( GL_MODELVIEW_MATRIX, modelview );
	glGetDoublev( GL_PROJECTION_MATRIX, projection );
	glGetIntegerv( GL_VIEWPORT, viewport );

	winX = (float)x;
	winY = (float)viewport[3] - (float)y;
	glReadPixels( x, int(winY), 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, &winZ );

	gluUnProject( winX, winY, winZ, modelview, projection, viewport, &posX, &posY, &posZ);

	posX = posX*100;
	posY = posY*100;
}


int findAvailableVirusSpot()
{
	for(int i=0; i<MAXVIRUSES; i++)
		if(viruses[i] == NULL) return i;

	return -1;
}

int findAvailableSpawnSpot()
{
	for(int i=0; i<MAXSPAWNS; i++)
		if(spawns[i] == NULL) return i;

	return -1;
}

void cycleSpawns()
{

	//if there's no room don't bother
	if(findAvailableVirusSpot()<0)return;

	for(int i=0; i<MAXSPAWNS; i++)
		if(spawns[i]!=NULL)
		{
			//try to spawn here
			virus* new_v = spawnVirus(spawns[i], frame_number);

			//skip this spawn if it doesn't spawn anything
			if(new_v==NULL)continue;

			int new_index = findAvailableVirusSpot();
			
			//virus array full....might as well abandon spawning a new virus
			if(new_index<0)return;

			//success
			playSample(AUDIO_VIRUS_SPAWN, AUDIO_LOOPMODE_SINGLE);
			viruses[new_index] = new_v;

		}
}

int getActiveViruses()
{
	int ret = 0;
	for(int i=0; i<MAXVIRUSES; i++)
		if(viruses[i]!=NULL)ret++;

	return ret;
}


void loadLevel(int level)
{
	char filename[128] = "levels/";
	char tmp[64];
	itoa(level, tmp, 10);
	strcat(tmp, ".txt");
	strcat(filename, tmp);
	
	FILE *fp = fopen(filename, "r");

	float x, y;
	int spawn_count;

	fscanf(fp, "%s\n", tmp); //"player"
	fscanf(fp, "%d\n", &pl.remaining[0]);
	fscanf(fp, "%d\n", &pl.remaining[1]);
	fscanf(fp, "%d\n", &pl.remaining[2]);
	pl.total[0]=pl.remaining[0]; pl.total[1]=pl.remaining[1]; pl.total[2]=pl.remaining[2]; 
	fscanf(fp, "%s\n", tmp); //"objective"
	fscanf(fp, "%d\n", &object.health);
	object.total_health = object.health;

	float tmp_f;
	fscanf(fp, "%f\n", &tmp_f);
	object.initial_scale = (double)tmp_f;
	object.scale = object.initial_scale;

	fscanf(fp, "%f\n%f", &x, &y);
	
	object.x = x;
	object.y = y;

	fscanf(fp, "%s\n", tmp);
	fscanf(fp, "%d\n", &spawn_count);

	int index;
	spawn* s=NULL;
	
	//for each spawn
	for(int i=0; i<spawn_count; i++)
	{
		//find an index in the spawns array
		index = findAvailableSpawnSpot();
		if(index<0)MessageBox(NULL,"Could not find spot in spawn array.","Init error",MB_OK | MB_ICONINFORMATION);
	
		s = createSpawn();

		//spawn location
		fscanf(fp, "%s\n", tmp); //SPAWN1
		fscanf(fp, "%f\n%f", &x, &y);
		s->x = x;
		s->y = y;

		//now do virus rates
		for(int j=0; j<VIRUS_TYPE_TOTAL; j++)
		{
			fscanf(fp, "%f\n", &x); //read next rate
			s->spawn_rates[j] = x;
		}

		//spawn type
		fscanf(fp, "%d\n", &s->type);

		fscanf(fp, "%f\n", &tmp_f);
		s->speed_additive = (double)tmp_f;

		//max viruses from this spawn
		fscanf(fp, "%d\n", &s->viruses_left);

		//move into array
		spawns[index] = s;
	}


	fclose(fp);
}

float readPixelUnderMouse(int x, int y)
{
	float wx, wy, wz;
/*
	GLint viewport[4];
	GLfloat modelview[16];
	GLfloat projection[16];
	
	glGetFloatv( GL_MODELVIEW_MATRIX, modelview );
	glGetFloatv( GL_PROJECTION_MATRIX, projection );
	glGetIntegerv( GL_VIEWPORT, viewport );

	wx = (float)x;
	wy = (float)viewport[3] - (float)y;
	glReadPixels( x, int(wy), 1, 1, GL_RED, GL_FLOAT, &wz );
*/

	// get some info about the screen size
	unsigned bpp     =  4;
	GLenum   format  =  GL_RGBA;


	// allocate memory to store image data
	unsigned char* pdata = new unsigned char[1*1*bpp];

	// read from front buffer
	glReadBuffer(GL_FRONT);

	// read pixel data
	glReadPixels(x,y,1,1,format,GL_UNSIGNED_BYTE,pdata);

global_red = pdata[0];
global_green  = pdata[1];
global_blue = pdata[2];

	free(pdata);

	return wz;

}

void box()
{
	glBegin(GL_LINE_STRIP);
	  glVertex3f(-0.5, -0.5, 0.0);
	  glVertex3f(-0.5, 0.5, 0.0);
	  glVertex3f(0.5, 0.5, 0.0);
	  glVertex3f(0.5, -0.5, 0.0);
	  glVertex3f(-0.5, -0.5, 0.0);
	glEnd();
}

void boxCoords(double left, double right, double top, double bottom)
{
	glBegin(GL_LINE_STRIP);
	  glVertex3f(left, bottom, 0.0);
	  glVertex3f(left, top, 0.0);
	  glVertex3f(right, top, 0.0);
	  glVertex3f(right, bottom, 0.0);
	  glVertex3f(left, bottom, 0.0);
	glEnd();
}

void bogusTexture()
{
	glPushMatrix();
	glTranslatef(-9999999.9, 0.0, 0.0);
	drawTexturedSquare(0);
	glPopMatrix();
}

//based on a mouse click at x,y
void updateCharge(double x, double y)
{
	double spanx = 0.55;

	double red_left = 2.11;
	double red_top = -2.43;
	double red_right = 2.5;
	double red_bottom = -3.24;

	double green_left = red_left + spanx;
	double green_right = red_right + spanx;
	double green_top = red_top;
	double green_bottom = red_bottom;

	double blue_left = green_left + spanx;
	double blue_right = green_right + spanx;
	double blue_top = green_top;
	double blue_bottom = green_bottom;

	//red
	if(x>red_left && x<red_right && y>red_bottom && y<red_top)
	{
		double red_ratio = (y - red_bottom) / (red_top - red_bottom);
		pl.charge[0] = min(pl.remaining[0],   100 * red_ratio);
	}

	//green
	if(x>green_left && x<green_right && y>green_bottom && y<green_top)
	{
		double green_ratio = (y - green_bottom) / (green_top - green_bottom);
		pl.charge[1] = min(pl.remaining[1], 100 * green_ratio);
	}

	//blue
	if(x>blue_left && x<blue_right && y>blue_bottom && y<blue_top)
	{
		double blue_ratio = (y - blue_bottom) / (blue_top - blue_bottom);
		pl.charge[2] = min(pl.remaining[2], 100 * blue_ratio);
	}
}


//non-spawned + onscreen
int countPotentialViruses()
{
	int ret = 0;

	ret = ret + getActiveViruses();
	for(int i=0; i<MAXSPAWNS; i++)
		if(spawns[i]!=NULL)
		{
			ret = ret + spawns[i]->viruses_left;
		}

	return ret;
}

//decrease frames remaining for this shot and modify the shot scale
void handleShot()
{
	//if we're shooting already, decrease frames
	if(shot)
	{
		//first frame of a shot?
		if(shot_frames==shot_frames_total)
		{
			pl.subtracted = 1;
		}

		if(shot_frames>0)
		{
			shot_frames--;

			double shot_scale = pl.scale + (double)(shot_frames_total-shot_frames)/(double)shot_frames_total / 2.0;
			pl.shot_scale = shot_scale;

			return;
		}
		else
		{
			checkShotOutcome();

			//that was the last frame of this shot, so interrupt shooting and reset frame count and subtracted
			shot = 0;
			shot_frames = shot_frames_total;

			//subtract remaining vitamins
			for(int i=0; i<3; i++)
				pl.remaining[i] = max(0, pl.remaining[i]-pl.charge[i]);

			//adjust charge if player doesn't have enough for another same charge
			for(i=0; i<3; i++)
				pl.charge[i] = min(pl.remaining[i], pl.charge[i]);

			pl.subtracted = 0;
			return;
		}
	}

	if(!shot)
	{

	}
}


void checkShotOutcome()
{
	if(!shot)return;

	for(int i=0; i<MAXVIRUSES; i++)
		if(viruses[i]!=NULL)
		{
			checkHit(&pl, viruses[i]);
			virus* a = checkDeadAndDestroy(viruses[i]);
			viruses[i] = a;
			if(viruses[i]==NULL)
			{
				playSampleRandomChannel(AUDIO_VIRUS_DEATH);
			}
		}

	return;
}

//put game in "you lose" state --- called only by checkLoseLevel()
void handleLostLevel()
{
	playSample(AUDIO_LOSE, AUDIO_LOOPMODE_SINGLE);
	game_state = STATE_LOST;
}

//check if player lost
void checkLoseLevel()
{
	//2 ways to lose
	//                -- no more vitamins (ammo)
	//                -- red cell HP == 0

	int out_of_ammo=0;
	int red_cell_dead=0;

	//no more ammo (vitamins)
	if(pl.remaining[0] == 0 &&
	   pl.remaining[1] == 0 &&
	   pl.remaining[2] == 0)       out_of_ammo=1;

	//red cell done
	if(object.health == 0)    red_cell_dead=1;

	if(out_of_ammo)
	{
		lost_level_texture = 29;
		handleLostLevel();
	}
	
	if(red_cell_dead)
	{
		handleLostLevel();
		lost_level_texture = 30;
	}

}


void loseLevelMessage()
{
	glPushMatrix();

	glColor3f(COLOR_WHITE);
	glTranslatef(field_translation_x, -field_translation_y, 0.0);
	glScalef(3.0, 3.0, 1.0);
	drawTexturedSquare(lost_level_texture);



	glPopMatrix();
}


void cleanUp()
{
	for(int i=0;i<MAXVIRUSES;i++)
		if(viruses[i]!=NULL)
		{
			free(viruses[i]);
			viruses[i]=NULL;
		}

	for(i=0;i<MAXSPAWNS;i++)
		if(spawns[i]!=NULL)
		{
			free(spawns[i]);
			spawns[i]=NULL;
		}
}


//put game in "you win" state --- called only by checkWinLevel()
void handleWonLevel()
{
	playSample(AUDIO_WIN, AUDIO_LOOPMODE_SINGLE);
	game_state = STATE_WIN;
}

void checkWinLevel()
{
	int virus_left = countPotentialViruses();
	
	if(virus_left == 0)
		handleWonLevel();
}

void winLevelMessage()
{
	glPushMatrix();

	glColor3f(COLOR_WHITE);
	glTranslatef(field_translation_x, -field_translation_y, 0.0);
	glScalef(3.0, 3.0, 1.0);
	drawTexturedSquare(31);



	glPopMatrix();
}



void playLevelTrack()
{
	int track_number = rand_2(TRACK_TOTAL);

	while(track_number == last_track)
		track_number = rand_2(TRACK_TOTAL);

	last_track = track_number;
	playTrack(track_number);
}


void handleVictoryState()
{
	glPushMatrix();

	glScalef(10.0, 8.0, 1.0);
	drawTexturedSquare(32);

	glPopMatrix();
}