#ifndef __GMD3_H__
#define __GMD3_H__

#include "Texture.h"
#include "constants.h"
#include "virus.h"
#include "objective.h"
#include "spawn.h"

//GLOBALS
Texture tex[MAXTEXTURES];
int game_state = STATE_MAIN;
virus *viruses[MAXVIRUSES];
objective object;
spawn *spawns[MAXSPAWNS];

void checkShotOutcome();
void handleShot();

void bogusTexture();
void box();
void boxCoords(double left, double right, double top, double bottom);

void playLevelTrack();

void loseLevelMessage();
void winLevelMessage();

void checkLoseLevel();
void checkWinLevel();

int countPotentialViruses();

//update charge based on mouse coords
void updateCharge(double x, double y);

//empty all arrays
void cleanUp();

void updateViruses();
void initializeLevel();
void GetMouseCoords(int x, int y);

float readPixelUnderMouse(int x, int y);

//load a level from file <level>.txt
void loadLevel(int level);

//in the main virus array
int findAvailableVirusSpot();

int findAvailableSpawnSpot();

//count how many viruses there are on screen
int getActiveViruses();

//try to spawn viruses from spawns
void cycleSpawns();

int GameFrame(GLvoid);
int GamePreFrame(GLvoid);
int GamePostFrame(GLvoid);
void audioInit();


void drawTexturedSquare(int texturenr);
void drawTexturedSquareCoords(int texturenr, double left, double right, double top, double bottom);

void handleMainState();
void handlePlayState();
void handleVictoryState();

#endif