#include "player.h"
#include "virus.h"
#include <math.h>
#include <windows.h>

void movePlayer(player* p, double dx, double dy, double field_width, double field_height)
{
	double left = -field_width/2.0;
	double right = field_width/2.0;
	double top = field_height/2.0;
	double bottom = -field_height/2.0;

	double player_radius = 1.0 * p->scale /2.0;

	//move him

	p->x = p->x + dx;
	p->y = p->y + dy;


	//collision with top
	if(p->y > top - player_radius)
	{
		p->y = top  - player_radius;
	}

	//collision with bottom
	if(p->y < bottom + player_radius)
	{
		p->y = bottom  + player_radius;
	}

	//collision with left
	if(p->x < left + player_radius)
	{
		p->x = left  + player_radius;
	}

	//collision with right
	if(p->x > right - player_radius)
	{
		p->x = right  - player_radius;
	}
}


void checkHit(player* p, virus* v)
{
	//proximity check
	double directionx = p->x - v->x;
	double directiony = p->y - v->y;

	//player-virus direction vector size
	double direction = sqrt(directionx*directionx + directiony*directiony);

	double shot_radius = 0.5 * p->shot_scale;
	double virus_radius = 0.5 * v->scale;

	//it's a hit!
	if(direction < shot_radius + virus_radius)
	{
		//take away virus' colors
		hitVirus(v, p->charge[0], p->charge[1], p->charge[2]);
	}

}