#include "spawn.h"
#include <windows.h>
#include <stdlib.h>
#include "virus.h"


spawn* createSpawn()
{
	spawn* gen = (spawn*)malloc(1*sizeof(spawn));
	
	gen->x = 8.0 * rand_1() - 4.0;
	gen->y = 5.6 * rand_1() - 2.8;
	gen->viruses_left = 5;
	gen->type = DIFFICULTY_EASY;

	gen->spawn_rates[VIRUS_TYPE_NOOB] = 10*BASE_SPAWN_RATE;
	gen->spawn_rates[VIRUS_TYPE_BERSERKER] = 5*BASE_SPAWN_RATE;
	gen->spawn_rates[VIRUS_TYPE_SEEKER] = 2*BASE_SPAWN_RATE;
	gen->spawn_rates[VIRUS_TYPE_TERMINATOR] = 0.5*BASE_SPAWN_RATE;
	
	return gen;
}

void destroySpawn(spawn* s)
{
	free(s);
	s = NULL;
}

virus* spawnVirus(spawn* s, int frame)
{
	if(s->viruses_left<=0)return NULL;

	virus* ret = NULL;
	int i;

	//rand to see if we'll actually generate
	for(i=0;i<VIRUS_TYPE_TOTAL;i++)
		//spawn this type of virus
		if(rand_1() < s->spawn_rates[i])
		{
				ret = createGenericVirus();
				ret->type = i;

				//virus starts out at spawn
				ret->x = s->x;
				ret->y = s->y;

				ret->type = i;
				if(i==VIRUS_TYPE_NOOB)ret->texture = 13;
				if(i==VIRUS_TYPE_BERSERKER)ret->texture = 12;
				if(i==VIRUS_TYPE_SEEKER)ret->texture = 15;
				if(i==VIRUS_TYPE_TERMINATOR)ret->texture = 16;

				break;
		}

	//dont bother with color adjustment if we're not spawning
	if(ret==NULL)return ret;

	//set color according to this spawn's difficulty here

	//EASIEST mode....virus colors satisfy following:
	//          ONE of the colors is 0
	//    THE OTHER colors can be either 0 or 75
	if(s->type==DIFFICULTY_EASY)
	{
		//select R or G or B to be 0
		int index = rand_2(3);
		
		for(int j=0;j<3;j++)
		{
			ret->color[j]=0;
		}

		int index_s = rand_2(3);
		while(index_s==index)index_s=rand_2(3);
		ret->color[index_s] = 80;

		for(j=0;j<3;j++)
			if(j!=index && j!=index_s)
			{
				int col = rand_2(2) * 80;
				ret->color[j] = col;
			}
	}//END EASY

	//MEDIUM mode....virus colors satisfy following:
	//          ONE of the colors is 0
	//    THE OTHER colors are between 15 and 100
	if(s->type==DIFFICULTY_MEDIUM)
	{
		//select R or G or B to be 0
		int index = rand_2(3);
		
		for(int j=0;j<3;j++)
		{
			ret->color[j]=0;
		}

		for(j=0;j<3;j++)
			if(j!=index)
			{
				int col = rand_1() * 85.0;
				ret->color[j] = 15 + col;
			}
	}//END MEDIUM

	//HARD mode....virus colors satisfy following:
	//    ALL colors are between 15 and 100
	if(s->type==DIFFICULTY_HARD)
	{

		for(int j=0;j<3;j++)
		{
			int col = rand_1() * 85.0;
				ret->color[j] = 15 + col;
		}
	}//END HARD


	//add the spawn's speed additive to the new virus' speed
	ret->speed += s->speed_additive;

	ret->last_decision = frame;
	s->viruses_left--;
	return ret;
}