#include <math.h>
#include "virus.h"
#include <windows.h>
#include <stdlib.h>

//between 0.0 and 1.0
double rand_1()
{
	return (double)rand() / (double)RAND_MAX;
}

//between 0 and n-1, integers
int rand_2(int n)
{
	double m = rand_1();
	int to_i = (int)(m * n);

	return to_i;
}

void normalize(double* x, double* y)
{
	double size = sqrt((*x) * (*x) + (*y) * (*y));
	*x = *x / size;
	*y = *y / size;

}

virus* checkDeadAndDestroy(virus* v)
{
	int threshold = 10;
	if(v->color[0] < threshold &&
	   v->color[1] < threshold &&
	   v->color[2] < threshold)
	{
		free(v);
		v = NULL;
	}

	return v;
}

virus* createGenericVirus()
{
	virus* gen = (virus*) malloc(1 * sizeof(virus));

	gen->color[0] = rand_1() * 100;
	gen->color[1] = rand_1() * 100;
	gen->color[2] = rand_1() * 100;

	gen->texture = 14;
	gen->x = 0.0;
	gen->y = 0.0;
	gen->dirx = rand_1() - 0.5;
	gen->diry = rand_1() - 0.5;

	//normalize
	double size = sqrt(gen->dirx*gen->dirx + gen->diry*gen->diry);
	gen->dirx = gen->dirx / size;
	gen->diry = gen->diry / size;

	gen->speed = 0.020 * rand_1() + 0.004;//can't have speed of 0

	//debug
	//gen->speed = 0.1;

	gen->angle = 0.0;
	gen->angle_increment = 10.0 * rand_1() + 0.5;

	gen->type = VIRUS_TYPE_SEEKER;

	gen->last_decision = 0;

	gen->scale = rand_1() / 8.0 + 0.20;

	return gen;
}

void hitVirus(virus* v, int red, int green, int blue)
{
	//if(v->type == VIRUS_TYPE_NOOB)
	//{
		//lose HP but clamp to 0
		v->color[0] = max(0, v->color[0] - red);
		v->color[1] = max(0, v->color[1] - green);
		v->color[2] = max(0, v->color[2] - blue);
	//}
}


void moveVirus(virus* v, double field_width, double field_height)
{
	double left = -field_width/2.0;
	double right = field_width/2.0;
	double top = field_height/2.0;
	double bottom = -field_height/2.0;
	//double virus_radius = sqrt(2.0) * v->scale /2.0;
	double virus_radius = 1.0 * v->scale /2.0;

	//move him
	v->x = v->x + v->dirx*v->speed;
	v->y = v->y + v->diry*v->speed;


	//collision with top
	if(v->y > top - virus_radius)
	{
		v->y = top  - virus_radius;
		v->diry = -v->diry;
	}

	//collision with bottom
	if(v->y < bottom + virus_radius)
	{
		v->y = bottom+virus_radius;
		v->diry = -v->diry;
	}

	//collision with left
	if(v->x < left + virus_radius)
	{
		v->x = left+virus_radius;
		v->dirx = -v->dirx;
	}

	//collision with right
	if(v->x > right - virus_radius)
	{
		v->x = right  - virus_radius;
		v->dirx = -v->dirx;
	}

	//rotate every frame
	v->angle += v->angle_increment;
}


void changeHandler(virus* v, int frame, objective* o)
{
	//change occurs every k frames
	int k;
	//and N slices are considered
	double N;

	//noobs just bounce around
	if(v->type == VIRUS_TYPE_NOOB) return;

	if(v->type == VIRUS_TYPE_BERSERKER)
	{
		k = 60;
		if(frame - v->last_decision >= k)
		{
				//randomly change angle
				double angle = rand_1() * 365.0;
				angle = angle * 3.14159265 / 180.0;
				v->dirx = cos(angle);
				v->diry = sin(angle);
				v->last_decision = frame;

				//increase speed
				v->speed += 0.0014;
		}
	}



	if(v->type == VIRUS_TYPE_SEEKER)
	{
		k = 240;
		N = 20.0;
		if(frame - v->last_decision >= k)
		{
				//adjusts direction toward objective, 0.0, 0.0 for debug
				double ox = o->x - v->x   +  rand_1()-0.5 * N/10.0;
				double oy = o->y - v->y   +  rand_1()-0.5 * N/10.0;

				normalize(&ox, &oy);

				v->dirx = ox;
				v->diry = oy;

				v->last_decision = frame;
		}
	}




	if(v->type == VIRUS_TYPE_TERMINATOR)
	{
		k = 90;
		if(frame - v->last_decision >= k)
		{
				//adjusts direction toward objective, 0.0, 0.0 for debug
				double ox = o->x - v->x;
				double oy = o->y - v->y;

				normalize(&ox, &oy);

				v->dirx = ox;
				v->diry = oy;

				v->last_decision = frame;
		}
	}


}











int checkHitByVirus(objective* o, virus* v)
{
	//proximity check
	double directionx = o->x - v->x;
	double directiony = o->y - v->y;

	//player-virus direction vector size
	double direction = sqrt(directionx*directionx + directiony*directiony);

	double objective_radius = 0.5 * o->scale;
	double virus_radius = 0.5 * v->scale;

	//it's a hit!
	if(direction < objective_radius + virus_radius)
	{
		//take away virus' colors
		o->health = max(0, o->health-1);

		return 1;
	}

	return 0;
}