#ifndef __VIRUS_H__
#define __VIRUS_H__

#include "objective.h"

#define VIRUS_TYPE_TOTAL 4
//basic virus
#define VIRUS_TYPE_NOOB 0
//changes direction often
#define VIRUS_TYPE_BERSERKER 1
//seeker frequently adjusts direction
#define VIRUS_TYPE_SEEKER 2
//won't stop until killed, and heads straight for objective
#define VIRUS_TYPE_TERMINATOR 3


struct virus
{
	int color[3];
	int texture;

	//position in the world, this is the centre of the sphere 'containing' this virus
	double x, y;

	//direction of movement, normalized
	double dirx, diry;

	//speed per frame
	double speed;

	//used for per-frame rotation
	double angle;
	double angle_increment;

	//how dangerous
	int type;

	//last frame in which this virus adjusted its direction
	int last_decision;

	//scale polygon by this amount
	double scale;
};

double rand_1();
int rand_2(int n);

//initialize a random noob virus
virus* createGenericVirus();


//hit a virus with a certain combination of RGB
void hitVirus(virus* v, int red, int green, int blue);

//did virus hit object?
int checkHitByVirus(objective* o, virus* v);

//called on all viruses on the level -- modified speed, direction based on collision with walls
void moveVirus(virus* v, double field_width, double field_height);

//for current frame, does this virus have to move?
void changeHandler(virus* v, int frame, objective* o);

//obvious .. nulls out pointer if virus is done .. (plays sound too?);
//returns pointer v (that might be NULL if virus is dead)
virus* checkDeadAndDestroy(virus* v);


#endif
